import processing.serial.*;

Boton bRojo, bAzul, bVerde, bNegro;
Medidor medidorPot;

int xC, yC, r;

Serial datosArduino;
String datosRecibidos, datosValidos;
int valorPot;

//datos para el medidor circular del valor del potenciómetro
int xM, yM, rM, angulo;

void setup(){
  size(600, 400);
  bRojo = new Boton(50, 50, 50, 50, color(250, 0, 0), color(250, 0, 0));
  bVerde = new Boton(50, 120, 50, 50, color(0, 250, 0), color(0, 250, 0));
  bAzul = new Boton(50, 190, 50, 50, color(0, 0, 250), color(0, 0, 250));
  bNegro = new Boton(50, 260, 50, 50, color(0), color(0));
  
  //creamos la comunicación serial
  datosArduino = new Serial(this, Serial.list()[3], 9600);
  
  //borrar el buffer de comunicación
  datosArduino.clear();
  
  valorPot = 0;
  rM = 100;
  xM = 3 * width /4;
  yM = height / 2;
  angulo = 0;
  
  medidorPot = new Medidor(xM, yM, rM, color(0, 200, 0), color(0), color(255));
  
}


void draw(){
  background(255);
  bRojo.show();
  bVerde.show();
  bAzul.show();
  bNegro.show();
  
  //checamos si hay datos enviados desde Arduino
  if (datosArduino.available() > 0){
    //leemos la información enviada
    datosRecibidos = datosArduino.readStringUntil(10);
  }else{
    datosRecibidos = null;
  }
  
  //checamos que haya datos válidos
  if (datosRecibidos != null && datosRecibidos.length() > 2){
    datosValidos = datosRecibidos.substring(0, datosRecibidos.length()-2);
    println(datosValidos);
    //extraemos el dato numérico de datosValidos
    valorPot = Integer.parseInt(datosValidos);
  }
  
  //medidor circular
  angulo = (int) map(valorPot, 0, 1023, 0, 180);
  medidorPot.angulo = angulo;
  medidorPot.show();
  
   
}

void mouseReleased(){
  if (bRojo.click()) datosArduino.write(1);
  if (bVerde.click()) datosArduino.write(2);
  if (bAzul.click()) datosArduino.write(3);
  if (bNegro.click()) datosArduino.write(0);
}
